/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package charfinder;

import edu.rit.pj.ParallelRegion;
import edu.rit.pj.ParallelTeam;
import java.util.Random;
/**
 *
 * @author kadir
 */
public class CharFinder {

     static int uzunluk = 400;
    static public String[] kelimeler = new String[uzunluk];
    static public char[] sesliler = new char[8];
    static public int[] sayac1, sayac2;

    public static void main(String[] args) throws Exception {
        sayac1 = new int[8];
        sayac2 = new int[8];
        String str = "aeıioöuü";
        sesliler = str.toCharArray();
        int takım = 4;
        ParallelTeam parTeam = new ParallelTeam(takım);
        parTeam.execute(new ParallelRegion() {

            public void run() {
                int idx = getThreadIndex();
                int div = uzunluk / takım;
                for (int l = (div * idx); l < div * (idx + 1); l++) {
                    kelimeler[l] = rastgeleKelimeUret(100);
                }
            }
        });
        parTeam = new ParallelTeam(takım*2);
        parTeam.execute(new ParallelRegion() {

            public void run() {
                int idx = getThreadIndex();
                for (int l = 0; l < uzunluk; l++) {
                    sayac1[idx] += harfAra(kelimeler[l], sesliler[idx]);
                }
            }
        });

        boolean flag = sonucDogruMu();
        if (flag) {
            System.out.println("doğru " + flag);
        } else {
            System.out.println("hata " + flag);
        }

        for (String l : kelimeler) {
            System.out.println(l);

        }

        for (int x = 0; x < 8; x++) {
            System.out.println(" " + sayac1[x] + " " + sayac2[x]);

        }

    }

    public static String rastgeleKelimeUret(int x) {
        Random r = new Random();
        String alfabe = "abcdefghıijklmnoöprstuüvxyz";
        String word = "";
        for (int i = 0; i < x; i++) {
            word += alfabe.charAt(r.nextInt(alfabe.length()));
        }
        return word;
    }

    public static int harfAra(String kelime, char c) {

        int count = 0;
        for (int i = 0; i < kelime.length(); i++) {
            if (kelime.charAt(i) == c) {
                count++;
            }
        }

        return count;
    }

    private static boolean sonucDogruMu() {

        boolean fl = true;
        for (int l = 0; l < uzunluk; l++) {
            for (int idx = 0; idx < 8; idx++) {
                sayac2[idx] += harfAra(kelimeler[l], sesliler[idx]);
            }

        }
        for (int s = 0; s < 8; s++) {
            if (sayac1[s] != sayac2[s]) {
                fl = false;
            }
        }

        return fl;
    }

    
}
